// ================================================================================
// (c) 2011 Altera Corporation. All rights reserved.
// Altera products are protected under numerous U.S. and foreign patents, maskwork
// rights, copyrights and other intellectual property laws.
//
// This reference design file, and your use thereof, is subject to and governed
// by the terms and conditions of the applicable Altera Reference Design License
// Agreement (either as signed by you, agreed by you upon download or as a
// "click-through" agreement upon installation andor found at www.altera.com).
// By using this reference design file, you indicate your acceptance of such terms
// and conditions between you and Altera Corporation.  In the event that you do
// not agree with such terms and conditions, you may not use the reference design
// file and please promptly destroy any copies you have made.
//
// This reference design file is being provided on an "as-is" basis and as an
// accommodation and therefore all warranties, representations or guarantees of
// any kind (whether express, implied or statutory) including, without limitation,
// warranties of merchantability, non-infringement, or fitness for a particular
// purpose, are specifically disclaimed.  By making this reference design file
// available, Altera expressly does not recommend, suggest or require that this
// reference design file be used in combination with any other product not
// provided by Altera.
// ================================================================================
//
// Modified Testbench File for the "Simulating Nios II Designs with Program Memory on External Flash
//    and SSRAM" Guide
// Jeff Wiencrot - 8/2/2011
//
// The file demonstrates modifications that a necessary due to a known issue with the flash memory
// and SSRAM bus functional models.  All changes are marked below with "CHANGE" comments.
//
// For more information, see "Simulating_Nios_II_Designs_with_Program_Memory_on_External_Flash_and_SSRAM.pdf"
//
// ================================================================================

`timescale 1 ps / 1 ps
module niosii_system_tb (
	);

	wire         niosii_system_inst_osc_clk_clk_in_bfm_clk_clk;                                               // niosii_system_inst_osc_clk_clk_in_bfm:clk -> [niosii_system_inst:osc_clk, niosii_system_inst_osc_clk_clk_in_reset_bfm:clk]
	wire         niosii_system_inst_osc_clk_clk_in_reset_bfm_reset_reset;                                     // niosii_system_inst_osc_clk_clk_in_reset_bfm:reset -> niosii_system_inst:reset_n
	wire   [3:0] niosii_system_inst_led_pio_external_connection_export;                                       // niosii_system_inst:out_port_from_the_led_pio -> niosii_system_inst_led_pio_external_connection_bfm:sig_export
	wire   [3:0] niosii_system_inst_button_pio_external_connection_bfm_conduit_export;                        // niosii_system_inst_button_pio_external_connection_bfm:sig_export -> niosii_system_inst:in_port_to_the_button_pio
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_outputenable_n_to_the_ext_ssram;      // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_outputenable_n_to_the_ext_ssram, niosii_system_inst:outputenable_n_to_the_ext_ssram]
	wire  [23:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_flash_ssram_tristate_bridge_address;  // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_flash_ssram_tristate_bridge_address, niosii_system_inst:flash_ssram_tristate_bridge_address]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_bwe_n_to_the_ext_ssram;               // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_bwe_n_to_the_ext_ssram, niosii_system_inst:bwe_n_to_the_ext_ssram]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_read_n_to_the_ext_flash;              // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_read_n_to_the_ext_flash, niosii_system_inst:read_n_to_the_ext_flash]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_adsc_n_to_the_ext_ssram;              // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_adsc_n_to_the_ext_ssram, niosii_system_inst:adsc_n_to_the_ext_ssram]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_reset_n_to_the_ext_ssram;             // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_reset_n_to_the_ext_ssram, niosii_system_inst:reset_n_to_the_ext_ssram]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_write_n_to_the_ext_flash;             // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_write_n_to_the_ext_flash, niosii_system_inst:write_n_to_the_ext_flash]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_select_n_to_the_ext_flash;            // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_select_n_to_the_ext_flash, niosii_system_inst:select_n_to_the_ext_flash]
	wire  [31:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_flash_ssram_tristate_bridge_data;     // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_flash_ssram_tristate_bridge_data, niosii_system_inst:flash_ssram_tristate_bridge_data]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_chipenable1_n_to_the_ext_ssram;       // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_chipenable1_n_to_the_ext_ssram, niosii_system_inst:chipenable1_n_to_the_ext_ssram]
	wire   [3:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_bw_n_to_the_ext_ssram;                // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:in_bw_n_to_the_ext_ssram, niosii_system_inst:bw_n_to_the_ext_ssram]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_outputenable_n_to_the_ext_ssram;     // flash_ssram_tristate_bridge_bridge_0_tcb_translator:outputenable_n_to_the_ext_ssram -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_outputenable_n_to_the_ext_ssram
	wire  [23:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_flash_ssram_tristate_bridge_address; // flash_ssram_tristate_bridge_bridge_0_tcb_translator:flash_ssram_tristate_bridge_address -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_flash_ssram_tristate_bridge_address
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_read_n_to_the_ext_flash;             // flash_ssram_tristate_bridge_bridge_0_tcb_translator:read_n_to_the_ext_flash -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_read_n_to_the_ext_flash
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_bwe_n_to_the_ext_ssram;              // flash_ssram_tristate_bridge_bridge_0_tcb_translator:bwe_n_to_the_ext_ssram -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_bwe_n_to_the_ext_ssram
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_adsc_n_to_the_ext_ssram;             // flash_ssram_tristate_bridge_bridge_0_tcb_translator:adsc_n_to_the_ext_ssram -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_adsc_n_to_the_ext_ssram
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_reset_n_to_the_ext_ssram;            // flash_ssram_tristate_bridge_bridge_0_tcb_translator:reset_n_to_the_ext_ssram -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_reset_n_to_the_ext_ssram
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_write_n_to_the_ext_flash;            // flash_ssram_tristate_bridge_bridge_0_tcb_translator:write_n_to_the_ext_flash -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_write_n_to_the_ext_flash
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_select_n_to_the_ext_flash;           // flash_ssram_tristate_bridge_bridge_0_tcb_translator:select_n_to_the_ext_flash -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_select_n_to_the_ext_flash
	wire  [31:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_flash_ssram_tristate_bridge_data;    // [] -> [flash_ssram_tristate_bridge_bridge_0_tcb_translator:flash_ssram_tristate_bridge_data, flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_flash_ssram_tristate_bridge_data]
	wire   [0:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_chipenable1_n_to_the_ext_ssram;      // flash_ssram_tristate_bridge_bridge_0_tcb_translator:chipenable1_n_to_the_ext_ssram -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_chipenable1_n_to_the_ext_ssram
	wire   [3:0] flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_bw_n_to_the_ext_ssram;               // flash_ssram_tristate_bridge_bridge_0_tcb_translator:bw_n_to_the_ext_ssram -> flash_ssram_tristate_bridge_pinSharer_0_pin_divider:in_bw_n_to_the_ext_ssram
	wire         ext_ssram_external_mem_bfm_clk_bfm_clk_clk;                                                  // ext_ssram_external_mem_bfm_clk_bfm:clk -> ext_ssram_external_mem_bfm:clk
	wire  [19:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_address_out;           // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_address_out -> ext_ssram_external_mem_bfm:cdt_address
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_chipselect_n_out;      // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_chipselect_n_out -> ext_ssram_external_mem_bfm:cdt_chipselect
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_begintransfer_n_out;   // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_begintransfer_n_out -> ext_ssram_external_mem_bfm:cdt_begintransfer
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_outputenable_n_out;    // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_outputenable_n_out -> ext_ssram_external_mem_bfm:cdt_outputenable
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_write_n_out;           // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_write_n_out -> ext_ssram_external_mem_bfm:cdt_write
	wire   [3:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_byteenable_n_out;      // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_byteenable_n_out -> ext_ssram_external_mem_bfm:cdt_byteenable
	wire  [31:0] ext_ssram_external_mem_bfm_conduit_tcm_data_out;                                             // [] -> [ext_ssram_external_mem_bfm:cdt_data_io, flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_data_out]
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_reset_n_out;           // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_ssram_tcm_reset_n_out -> ext_ssram_external_mem_bfm:cdt_reset
	wire         ext_flash_external_mem_bfm_clk_bfm_clk_clk;                                                  // ext_flash_external_mem_bfm_clk_bfm:clk -> ext_flash_external_mem_bfm:clk
	wire  [23:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_address_out;           // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_flash_tcm_address_out -> ext_flash_external_mem_bfm:cdt_address
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_chipselect_n_out;      // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_flash_tcm_chipselect_n_out -> ext_flash_external_mem_bfm:cdt_chipselect
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_write_n_out;           // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_flash_tcm_write_n_out -> ext_flash_external_mem_bfm:cdt_write
	wire  [15:0] ext_flash_external_mem_bfm_conduit_tcm_data_out;                                             // [] -> [ext_flash_external_mem_bfm:cdt_data_io, flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_flash_tcm_data_out]
	wire   [0:0] flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_read_n_out;            // flash_ssram_tristate_bridge_pinSharer_0_pin_divider:ext_flash_tcm_read_n_out -> ext_flash_external_mem_bfm:cdt_read
	
	// CHANGE: add system_clk wire and connect to system_clk port of Nios II system
	wire system_clk;
	
	niosii_system_tb_niosii_system_inst niosii_system_inst (
		.osc_clk                             (niosii_system_inst_osc_clk_clk_in_bfm_clk_clk),                                              //                           osc_clk_clk_in.clk
		.ssram_clk                           (),                                                                                           //                               sys_pll_c1.clk
		.system_clk                          (system_clk),                                                                                           //                               c0_out_clk.clk
		.out_port_from_the_led_pio           (niosii_system_inst_led_pio_external_connection_export),                                      //              led_pio_external_connection.export
		.reset_n                             (niosii_system_inst_osc_clk_clk_in_reset_bfm_reset_reset),                                    //                     osc_clk_clk_in_reset.reset_n
		.in_port_to_the_button_pio           (niosii_system_inst_button_pio_external_connection_bfm_conduit_export),                       //           button_pio_external_connection.export
		.select_n_to_the_ext_flash           (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_select_n_to_the_ext_flash),           // flash_ssram_tristate_bridge_bridge_0_out.select_n_to_the_ext_flash
		.flash_ssram_tristate_bridge_address (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_flash_ssram_tristate_bridge_address), //                                         .flash_ssram_tristate_bridge_address
		.read_n_to_the_ext_flash             (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_read_n_to_the_ext_flash),             //                                         .read_n_to_the_ext_flash
		.bw_n_to_the_ext_ssram               (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_bw_n_to_the_ext_ssram),               //                                         .bw_n_to_the_ext_ssram
		.adsc_n_to_the_ext_ssram             (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_adsc_n_to_the_ext_ssram),             //                                         .adsc_n_to_the_ext_ssram
		.write_n_to_the_ext_flash            (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_write_n_to_the_ext_flash),            //                                         .write_n_to_the_ext_flash
		.outputenable_n_to_the_ext_ssram     (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_outputenable_n_to_the_ext_ssram),     //                                         .outputenable_n_to_the_ext_ssram
		.reset_n_to_the_ext_ssram            (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_reset_n_to_the_ext_ssram),            //                                         .reset_n_to_the_ext_ssram
		.flash_ssram_tristate_bridge_data    (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_flash_ssram_tristate_bridge_data),    //                                         .flash_ssram_tristate_bridge_data
		.chipenable1_n_to_the_ext_ssram      (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_chipenable1_n_to_the_ext_ssram),      //                                         .chipenable1_n_to_the_ext_ssram
		.bwe_n_to_the_ext_ssram              (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_bwe_n_to_the_ext_ssram)               //                                         .bwe_n_to_the_ext_ssram
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (50)
	) niosii_system_inst_osc_clk_clk_in_bfm (
		.clk (niosii_system_inst_osc_clk_clk_in_bfm_clk_clk)  // clk.clk
	);

	altera_avalon_reset_source #(
		.ASSERT_HIGH_RESET    (0),
		.INITIAL_RESET_CYCLES (50)
	) niosii_system_inst_osc_clk_clk_in_reset_bfm (
		.reset (niosii_system_inst_osc_clk_clk_in_reset_bfm_reset_reset), // reset.reset_n
		.clk   (niosii_system_inst_osc_clk_clk_in_bfm_clk_clk)            //   clk.clk
	);

	niosii_system_tb_niosii_system_inst_led_pio_external_connection_bfm niosii_system_inst_led_pio_external_connection_bfm (
		.sig_export (niosii_system_inst_led_pio_external_connection_export)  // conduit.export
	);

	niosii_system_tb_niosii_system_inst_button_pio_external_connection_bfm niosii_system_inst_button_pio_external_connection_bfm (
		.sig_export (niosii_system_inst_button_pio_external_connection_bfm_conduit_export)  // conduit.export
	);

	niosii_system_tb_flash_ssram_tristate_bridge_bridge_0_tcb_translator flash_ssram_tristate_bridge_bridge_0_tcb_translator (
		.in_read_n_to_the_ext_flash             (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_read_n_to_the_ext_flash),              //  in.read_n_to_the_ext_flash
		.in_select_n_to_the_ext_flash           (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_select_n_to_the_ext_flash),            //    .select_n_to_the_ext_flash
		.in_flash_ssram_tristate_bridge_address (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_flash_ssram_tristate_bridge_address),  //    .flash_ssram_tristate_bridge_address
		.in_bwe_n_to_the_ext_ssram              (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_bwe_n_to_the_ext_ssram),               //    .bwe_n_to_the_ext_ssram
		.in_adsc_n_to_the_ext_ssram             (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_adsc_n_to_the_ext_ssram),              //    .adsc_n_to_the_ext_ssram
		.in_bw_n_to_the_ext_ssram               (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_bw_n_to_the_ext_ssram),                //    .bw_n_to_the_ext_ssram
		.in_flash_ssram_tristate_bridge_data    (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_flash_ssram_tristate_bridge_data),     //    .flash_ssram_tristate_bridge_data
		.in_reset_n_to_the_ext_ssram            (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_reset_n_to_the_ext_ssram),             //    .reset_n_to_the_ext_ssram
		.in_outputenable_n_to_the_ext_ssram     (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_outputenable_n_to_the_ext_ssram),      //    .outputenable_n_to_the_ext_ssram
		.in_write_n_to_the_ext_flash            (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_write_n_to_the_ext_flash),             //    .write_n_to_the_ext_flash
		.in_chipenable1_n_to_the_ext_ssram      (flash_ssram_tristate_bridge_bridge_0_tcb_translator_in_chipenable1_n_to_the_ext_ssram),       //    .chipenable1_n_to_the_ext_ssram
		.read_n_to_the_ext_flash                (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_read_n_to_the_ext_flash),             // out.read_n_to_the_ext_flash
		.select_n_to_the_ext_flash              (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_select_n_to_the_ext_flash),           //    .select_n_to_the_ext_flash
		.flash_ssram_tristate_bridge_address    (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_flash_ssram_tristate_bridge_address), //    .flash_ssram_tristate_bridge_address
		.bwe_n_to_the_ext_ssram                 (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_bwe_n_to_the_ext_ssram),              //    .bwe_n_to_the_ext_ssram
		.adsc_n_to_the_ext_ssram                (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_adsc_n_to_the_ext_ssram),             //    .adsc_n_to_the_ext_ssram
		.bw_n_to_the_ext_ssram                  (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_bw_n_to_the_ext_ssram),               //    .bw_n_to_the_ext_ssram
		.flash_ssram_tristate_bridge_data       (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_flash_ssram_tristate_bridge_data),    //    .flash_ssram_tristate_bridge_data
		.reset_n_to_the_ext_ssram               (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_reset_n_to_the_ext_ssram),            //    .reset_n_to_the_ext_ssram
		.outputenable_n_to_the_ext_ssram        (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_outputenable_n_to_the_ext_ssram),     //    .outputenable_n_to_the_ext_ssram
		.write_n_to_the_ext_flash               (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_write_n_to_the_ext_flash),            //    .write_n_to_the_ext_flash
		.chipenable1_n_to_the_ext_ssram         (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_chipenable1_n_to_the_ext_ssram)       //    .chipenable1_n_to_the_ext_ssram
	);

	niosii_system_tb_flash_ssram_tristate_bridge_pinSharer_0_pin_divider flash_ssram_tristate_bridge_pinsharer_0_pin_divider (
		.in_flash_ssram_tristate_bridge_address (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_flash_ssram_tristate_bridge_address), //            in.flash_ssram_tristate_bridge_address
		.in_read_n_to_the_ext_flash             (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_read_n_to_the_ext_flash),             //              .read_n_to_the_ext_flash
		.in_write_n_to_the_ext_flash            (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_write_n_to_the_ext_flash),            //              .write_n_to_the_ext_flash
		.in_flash_ssram_tristate_bridge_data    (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_flash_ssram_tristate_bridge_data),    //              .flash_ssram_tristate_bridge_data
		.in_select_n_to_the_ext_flash           (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_select_n_to_the_ext_flash),           //              .select_n_to_the_ext_flash
		.in_chipenable1_n_to_the_ext_ssram      (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_chipenable1_n_to_the_ext_ssram),      //              .chipenable1_n_to_the_ext_ssram
		.in_bw_n_to_the_ext_ssram               (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_bw_n_to_the_ext_ssram),               //              .bw_n_to_the_ext_ssram
		.in_outputenable_n_to_the_ext_ssram     (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_outputenable_n_to_the_ext_ssram),     //              .outputenable_n_to_the_ext_ssram
		.in_bwe_n_to_the_ext_ssram              (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_bwe_n_to_the_ext_ssram),              //              .bwe_n_to_the_ext_ssram
		.in_reset_n_to_the_ext_ssram            (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_reset_n_to_the_ext_ssram),            //              .reset_n_to_the_ext_ssram
		.in_adsc_n_to_the_ext_ssram             (flash_ssram_tristate_bridge_bridge_0_tcb_translator_out_adsc_n_to_the_ext_ssram),             //              .adsc_n_to_the_ext_ssram
		.ext_flash_tcm_address_out              (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_address_out),           // ext_flash_tcm.tcm_address_out
		.ext_flash_tcm_read_n_out               (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_read_n_out),            //              .tcm_read_n_out
		.ext_flash_tcm_write_n_out              (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_write_n_out),           //              .tcm_write_n_out
		.ext_flash_tcm_data_out                 (ext_flash_external_mem_bfm_conduit_tcm_data_out),                                             //              .tcm_data_out
		.ext_flash_tcm_chipselect_n_out         (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_chipselect_n_out),      //              .tcm_chipselect_n_out
		.ext_ssram_tcm_chipselect_n_out         (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_chipselect_n_out),      // ext_ssram_tcm.tcm_chipselect_n_out
		.ext_ssram_tcm_byteenable_n_out         (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_byteenable_n_out),      //              .tcm_byteenable_n_out
		.ext_ssram_tcm_outputenable_n_out       (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_outputenable_n_out),    //              .tcm_outputenable_n_out
		.ext_ssram_tcm_write_n_out              (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_write_n_out),           //              .tcm_write_n_out
		.ext_ssram_tcm_data_out                 (ext_ssram_external_mem_bfm_conduit_tcm_data_out),                                             //              .tcm_data_out
		.ext_ssram_tcm_address_out              (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_address_out),           //              .tcm_address_out
		.ext_ssram_tcm_reset_n_out              (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_reset_n_out),           //              .tcm_reset_n_out
		.ext_ssram_tcm_begintransfer_n_out      (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_begintransfer_n_out)    //              .tcm_begintransfer_n_out
	);
	
	
	// CHANGE: connect the system_clk wire to the clk input of the SSRAM BFM (in place of ext_ssram_external_mem_bfm_clk_bfm_clk_clk)
	altera_external_memory_bfm #(
		.USE_CHIPSELECT           (1),
		.USE_WRITE                (1),
		.USE_READ                 (0),
		.USE_OUTPUTENABLE         (1),
		.USE_BEGINTRANSFER        (1),
		.ACTIVE_LOW_BYTEENABLE    (1),
		.ACTIVE_LOW_CHIPSELECT    (1),
		.ACTIVE_LOW_WRITE         (1),
		.ACTIVE_LOW_READ          (0),
		.ACTIVE_LOW_OUTPUTENABLE  (1),
		.ACTIVE_LOW_BEGINTRANSFER (1),
		.ACTIVE_LOW_RESET         (1),
		.CDT_ADDRESS_W            (20),
		.CDT_SYMBOL_W             (8),
		.CDT_NUMSYMBOLS           (4),
		.INIT_FILE                ("altera_external_memory_bfm.hex"),
		.CDT_READ_LATENCY         (2)
	) ext_ssram_external_mem_bfm (
		.clk               (system_clk),                                                //     clk.clk
		.cdt_write         (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_write_n_out),         // conduit.tcm_write_n_out
		.cdt_chipselect    (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_chipselect_n_out),    //        .tcm_chipselect_n_out
		.cdt_outputenable  (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_outputenable_n_out),  //        .tcm_outputenable_n_out
		.cdt_begintransfer (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_begintransfer_n_out), //        .tcm_begintransfer_n_out
		.cdt_address       (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_address_out),         //        .tcm_address_out
		.cdt_data_io       (ext_ssram_external_mem_bfm_conduit_tcm_data_out),                                           //        .tcm_data_out
		.cdt_byteenable    (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_byteenable_n_out),    //        .tcm_byteenable_n_out
		.cdt_reset         (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_ssram_tcm_tcm_reset_n_out),         //        .tcm_reset_n_out
		.cdt_read          (1'b0)                                                                                       // (terminated)
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (85)
	) ext_ssram_external_mem_bfm_clk_bfm (
		.clk (ext_ssram_external_mem_bfm_clk_bfm_clk_clk)  // clk.clk
	);

	
	// CHANGE: connect the system_clk wire to the clk input of the flash memory BFM (in place of ext_flash_external_mem_bfm_clk_bfm_clk_clk)
	altera_external_memory_bfm #(
		.USE_CHIPSELECT           (1),
		.USE_WRITE                (1),
		.USE_READ                 (1),
		.USE_OUTPUTENABLE         (0),
		.USE_BEGINTRANSFER        (0),
		.ACTIVE_LOW_BYTEENABLE    (0),
		.ACTIVE_LOW_CHIPSELECT    (1),
		.ACTIVE_LOW_WRITE         (1),
		.ACTIVE_LOW_READ          (1),
		.ACTIVE_LOW_OUTPUTENABLE  (0),
		.ACTIVE_LOW_BEGINTRANSFER (0),
		.ACTIVE_LOW_RESET         (0),
		.CDT_ADDRESS_W            (24),
		.CDT_SYMBOL_W             (8),
		.CDT_NUMSYMBOLS           (2),
		.INIT_FILE                ("altera_external_memory_bfm.hex"),
		.CDT_READ_LATENCY         (0)
	) ext_flash_external_mem_bfm (
		.clk               (system_clk),                                             //     clk.clk
		.cdt_write         (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_write_n_out),      // conduit.tcm_write_n_out
		.cdt_read          (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_read_n_out),       //        .tcm_read_n_out
		.cdt_chipselect    (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_chipselect_n_out), //        .tcm_chipselect_n_out
		.cdt_address       (flash_ssram_tristate_bridge_pinsharer_0_pin_divider_ext_flash_tcm_tcm_address_out),      //        .tcm_address_out
		.cdt_data_io       (ext_flash_external_mem_bfm_conduit_tcm_data_out),                                        //        .tcm_data_out
		.cdt_outputenable  (1'b0),                                                                                   // (terminated)
		.cdt_begintransfer (1'b0),                                                                                   // (terminated)
		.cdt_byteenable    (2'b11),                                                                                  // (terminated)
		.cdt_reset         (1'b0)                                                                                    // (terminated)
	);

	altera_avalon_clock_source #(
		.CLOCK_RATE (85)
	) ext_flash_external_mem_bfm_clk_bfm (
		.clk (ext_flash_external_mem_bfm_clk_bfm_clk_clk)  // clk.clk
	);

endmodule
